package edu.hsog.db;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Random;

public class GUI {
    public GUI() {

        slider1.setMinimum(1);
        slider1.setMaximum(5);
        slider1.setMajorTickSpacing(1);
        slider1.setPaintTicks(true);
        slider1.setPaintLabels(true);
        slider1.setValue(3);


        exitButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });
        initConPoolButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Globals.initConnectionPool();
                conLabel.setText("verbunden");
            }
        });
        countButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                int c = DBQueries.count();
                countJLabel.setText("Count: " + c);
            }
        });
        loginButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                String user = userTextField.getText();
                String passwd = passwdTextField.getText();
                boolean loggedIn = DBQueries.login(user, passwd);
                if (loggedIn) {
                    conLabel.setText("logged in");

                    Globals.currentmail = user;
                } else {
                    Globals.currentmail = null;

                    conLabel.setText("not logged in");
                }
            }
        });
        loadImageButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                imageLabel.setIcon(Converter.mergeIcons(DBQueries.showAll()));


            }
        });
        getImageByZahlGadgetsAscButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                String eingabe = userTextField.getText();
                ImageIcon i = DBQueries.getImage(Integer.parseInt(eingabe));
                imageLabel.setIcon(i);
            }
        });
        getImageByUrlGadgetsURLButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String urlEingabe = userTextField.getText().trim();
                ImageIcon i = DBQueries.getImageByUrl(urlEingabe);
                imageLabel.setIcon(i);
            }
        });
        getImageByDescGadgetsDescButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String descEingabe = userTextField.getText().trim();
                ImageIcon i = DBQueries.getImageByDesc(descEingabe);
                imageLabel.setIcon(i);
            }
        });

        insertImageByURLEmailButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                Random random = new Random();
                int randomNumber = random.nextInt(1000);
                String gadgetUrl = Integer.toString(randomNumber);
                String eingabe = "abc@web.de";
                DBQueries.insertImageUrlEmail(gadgetUrl,eingabe);

            }
        });
        updateBildLikeKeywordsButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                    String eingabe = "%"+userTextField.getText()+"%";
                    DBQueries.updateItemLikeKeywords(eingabe);
            }
        });
        iconListEmailButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                ArrayList<Icon>ergebnis = DBQueries.iconListEmail(userTextField.getText());
                imageLabel.setIcon(Converter.mergeIcons(ergebnis));

            }
        });
        searchGadgetsByUrlButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {


                int ergebnis = DBQueries.searchGadgetsUrlIndex(userTextField.getText());
                imageLabel.setText(" :"+ ergebnis);
            }
        });
        zeilenSpaltenButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                int row = Integer.parseInt(userTextField.getText());
                int col = Integer.parseInt((passwdTextField.getText()));
                String ergebnis = DBQueries.zeilenSpalten(row,col);
                imageLabel.setText(ergebnis);
            }
        });
        emailPasswordButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

            DTO ergebnis = DBQueries.emailPassword(userTextField.getText());

            String s1 = ergebnis.email;
            String s2 = ergebnis.password;

            passwdTextField.setText(s1 +" #" +s2);

            }
        });
        sumGefallenByURLButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                String eingabe = userTextField.getText();
                passwdTextField.setText(String.valueOf(DBQueries.sumGefallenUrl(eingabe)));
            }
        });
        ersteKommentarButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String eingabe = userTextField.getText();
                imageLabel.setText(DBQueries.firstKommentar(eingabe));
            }
        });
        getBestRatedGadgetsButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                String eingabe = userTextField.getText();
                passwdTextField.setText(DBQueries.Kommentar(eingabe));
                System.out.println(DBQueries.Kommentar(eingabe));
            }
        });

    }

    public JPanel getMasterPanel() {
        return masterPanel;
    }

    private JPanel masterPanel;
    private JButton exitButton;
    private JButton initConPoolButton;
    private JButton countButton;
    private JLabel conLabel;
    private JLabel countJLabel;
    private JTextField userTextField;
    private JTextField passwdTextField;
    private JButton loginButton;
    private JButton registerButton;
    private JLabel imageLabel;
    private JButton loadImageButton;
    private JSlider slider1;
    private JButton getImageByZahlGadgetsAscButton;
    private JButton getImageByUrlGadgetsURLButton;
    private JButton getImageByDescGadgetsDescButton;
    private JButton insertImageByURLEmailButton;
    private JButton updateBildLikeKeywordsButton;
    private JButton iconListEmailButton;
    private JButton searchGadgetsByUrlButton;
    private JButton zeilenSpaltenButton;
    private JButton emailPasswordButton;
    private JButton sumGefallenByURLButton;
    private JButton ersteKommentarButton;
    private JButton getBestRatedGadgetsButton;
    private JButton addCommentSliderButton;
    private JButton bildButton;


}
